// ##### ENDFILE "GuestMonitorChangedEventWrap.cpp"


// ##### BEGINFILE "StorageDeviceChangedEventWrap.cpp"
/** @file
 * VirtualBox API class wrapper code for IStorageDeviceChangedEvent.
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl
 * Generator: src/VBox/Main/idl/apiwrap-server.xsl
 */

/**
 * Copyright (C) 2010-2016 Oracle Corporation
 *
 * This file is part of VirtualBox Open Source Edition (OSE), as
 * available from http://www.virtualbox.org. This file is free software;
 * you can redistribute it and/or modify it under the terms of the GNU
 * General Public License (GPL) as published by the Free Software
 * Foundation, in version 2 as it comes in the "COPYING" file of the
 * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 */

#define LOG_GROUP_MAIN_OVERRIDE LOG_GROUP_MAIN_STORAGEDEVICECHANGEDEVENT

#include "StorageDeviceChangedEventWrap.h"
#include "Logging.h"
#ifdef VBOX_WITH_DTRACE_R3_MAIN
# include "dtrace/VBoxAPI.h"
#endif

DEFINE_EMPTY_CTOR_DTOR(StorageDeviceChangedEventWrap)

//
// IEvent properties
//

STDMETHODIMP StorageDeviceChangedEventWrap::COMGETTER(Type)(VBoxEventType_T *aType)
{
    LogRelFlow(("{%p} %s: enter aType=%p\n", this, "StorageDeviceChangedEvent::getType", aType));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aType);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_TYPE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getType(aType);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_TYPE_RETURN(this, hrc, 0 /*normal*/,*aType);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_TYPE_RETURN(this, hrc, 1 /*hrc exception*/,*aType);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_TYPE_RETURN(this, hrc, 9 /*unhandled exception*/,*aType);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aType=%RU32 hrc=%Rhrc\n", this, "StorageDeviceChangedEvent::getType", *aType, hrc));
    return hrc;
}

STDMETHODIMP StorageDeviceChangedEventWrap::COMGETTER(Source)(IEventSource **aSource)
{
    LogRelFlow(("{%p} %s: enter aSource=%p\n", this, "StorageDeviceChangedEvent::getSource", aSource));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aSource);
        ComTypeOutConverter<IEventSource> TmpSource(aSource);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_SOURCE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getSource(TmpSource.ptr());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_SOURCE_RETURN(this, hrc, 0 /*normal*/,(void *)TmpSource.ptr());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_SOURCE_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_SOURCE_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aSource=%p hrc=%Rhrc\n", this, "StorageDeviceChangedEvent::getSource", *aSource, hrc));
    return hrc;
}

STDMETHODIMP StorageDeviceChangedEventWrap::COMGETTER(Waitable)(BOOL *aWaitable)
{
    LogRelFlow(("{%p} %s: enter aWaitable=%p\n", this, "StorageDeviceChangedEvent::getWaitable", aWaitable));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aWaitable);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_WAITABLE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getWaitable(aWaitable);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_WAITABLE_RETURN(this, hrc, 0 /*normal*/,*aWaitable != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_WAITABLE_RETURN(this, hrc, 1 /*hrc exception*/,*aWaitable != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_WAITABLE_RETURN(this, hrc, 9 /*unhandled exception*/,*aWaitable != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aWaitable=%RTbool hrc=%Rhrc\n", this, "StorageDeviceChangedEvent::getWaitable", *aWaitable, hrc));
    return hrc;
}

//
// IStorageDeviceChangedEvent properties
//

STDMETHODIMP StorageDeviceChangedEventWrap::COMGETTER(StorageDevice)(IMediumAttachment **aStorageDevice)
{
    LogRelFlow(("{%p} %s: enter aStorageDevice=%p\n", this, "StorageDeviceChangedEvent::getStorageDevice", aStorageDevice));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aStorageDevice);
        ComTypeOutConverter<IMediumAttachment> TmpStorageDevice(aStorageDevice);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_STORAGEDEVICE_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getStorageDevice(TmpStorageDevice.ptr());
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_STORAGEDEVICE_RETURN(this, hrc, 0 /*normal*/,(void *)TmpStorageDevice.ptr());
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_STORAGEDEVICE_RETURN(this, hrc, 1 /*hrc exception*/,0);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_STORAGEDEVICE_RETURN(this, hrc, 9 /*unhandled exception*/,0);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aStorageDevice=%p hrc=%Rhrc\n", this, "StorageDeviceChangedEvent::getStorageDevice", *aStorageDevice, hrc));
    return hrc;
}

STDMETHODIMP StorageDeviceChangedEventWrap::COMGETTER(Removed)(BOOL *aRemoved)
{
    LogRelFlow(("{%p} %s: enter aRemoved=%p\n", this, "StorageDeviceChangedEvent::getRemoved", aRemoved));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aRemoved);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_REMOVED_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getRemoved(aRemoved);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_REMOVED_RETURN(this, hrc, 0 /*normal*/,*aRemoved != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_REMOVED_RETURN(this, hrc, 1 /*hrc exception*/,*aRemoved != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_REMOVED_RETURN(this, hrc, 9 /*unhandled exception*/,*aRemoved != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aRemoved=%RTbool hrc=%Rhrc\n", this, "StorageDeviceChangedEvent::getRemoved", *aRemoved, hrc));
    return hrc;
}

STDMETHODIMP StorageDeviceChangedEventWrap::COMGETTER(Silent)(BOOL *aSilent)
{
    LogRelFlow(("{%p} %s: enter aSilent=%p\n", this, "StorageDeviceChangedEvent::getSilent", aSilent));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aSilent);
        
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_SILENT_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = getSilent(aSilent);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_SILENT_RETURN(this, hrc, 0 /*normal*/,*aSilent != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_SILENT_RETURN(this, hrc, 1 /*hrc exception*/,*aSilent != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_GET_SILENT_RETURN(this, hrc, 9 /*unhandled exception*/,*aSilent != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave *aSilent=%RTbool hrc=%Rhrc\n", this, "StorageDeviceChangedEvent::getSilent", *aSilent, hrc));
    return hrc;
}


//
// IEvent methods
//

STDMETHODIMP StorageDeviceChangedEventWrap::SetProcessed()
{
    LogRelFlow(("{%p} %s:enter\n", this, "StorageDeviceChangedEvent::setProcessed"));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {



#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_SETPROCESSED_ENTER(this);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = setProcessed();
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_SETPROCESSED_RETURN(this, hrc, 0 /*normal*/);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_SETPROCESSED_RETURN(this, hrc, 1 /*hrc exception*/);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_SETPROCESSED_RETURN(this, hrc, 9 /*unhandled exception*/);
#endif
    }

    LogRelFlow(("{%p} %s: leave hrc=%Rhrc\n", this, "StorageDeviceChangedEvent::setProcessed", hrc));
    return hrc;
}

STDMETHODIMP StorageDeviceChangedEventWrap::WaitProcessed(LONG aTimeout,
                                                          BOOL *aResult)
{
    LogRelFlow(("{%p} %s:enter aTimeout=%RI32 aResult=%p\n", this, "StorageDeviceChangedEvent::waitProcessed", aTimeout, aResult));

    VirtualBoxBase::clearError();

    HRESULT hrc;

    try
    {
        CheckComArgOutPointerValidThrow(aResult);


        
        

#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_WAITPROCESSED_ENTER(this, aTimeout);
#endif
        AutoCaller autoCaller(this);
        hrc = autoCaller.rc();
        if (SUCCEEDED(hrc))
        {
            hrc = waitProcessed(aTimeout,
                                aResult);
        }
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_WAITPROCESSED_RETURN(this, hrc, 0 /*normal*/, aTimeout, *aResult != FALSE);
#endif
    }
    catch (HRESULT hrc2)
    {
        hrc = hrc2;
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_WAITPROCESSED_RETURN(this, hrc, 1 /*hrc exception*/, aTimeout, *aResult != FALSE);
#endif
    }
    catch (...)
    {
        hrc = VirtualBoxBase::handleUnexpectedExceptions(this, RT_SRC_POS);
#ifdef VBOX_WITH_DTRACE_R3_MAIN
        VBOXAPI_STORAGEDEVICECHANGEDEVENT_WAITPROCESSED_RETURN(this, hrc, 9 /*unhandled exception*/, aTimeout, *aResult != FALSE);
#endif
    }

    LogRelFlow(("{%p} %s: leave aResult=%RTbool hrc=%Rhrc\n", this, "StorageDeviceChangedEvent::waitProcessed", *aResult, hrc));
    return hrc;
}

//
// IStorageDeviceChangedEvent methods
//

#ifdef VBOX_WITH_XPCOM
NS_DECL_CLASSINFO(StorageDeviceChangedEventWrap)
NS_IMPL_THREADSAFE_ISUPPORTS2_CI(StorageDeviceChangedEventWrap, IStorageDeviceChangedEvent, IEvent)
#endif // VBOX_WITH_XPCOM

